/*


THIS IS FOR USE WITH  A PROMINI IN THE HAMMOND ENCLOSURE MAXTACH1593N
IN THE H:\AJAWAM\eng\MAXTACH
USING AN LCM-S01602DSF/A (STANDARD 1620 LCD PINOUT WITH GND AT PIN 1)

efuse 05
hfuse D6
lfuse FF

LiquidCrystal(rs, enable, d4, d5, d6, d7) 
*/
#include <Time.h>
#include <TimeAlarms.h>
#include <LiquidCrystal.h>

LiquidCrystal lcd(9, 8, 7, 6, 5, 4);

int pin = 2;
float timet = 0;

volatile float rpm_array[5] = {0,0,0,0,0};

void setup()
{
  
  lcd.begin(16, 2);
  // Print a message to the LCD.
 lcd.print("Current RPM:");  
  
pinMode(pin, INPUT);

setTime(0,00,00,1,1,10); // set time to 0:00:00 Jan 1 2010

}



void loop()
{
  
  digitalClockDisplay(); 
  
  
  float rpm = 0;
timet = pulseIn(pin, HIGH);


 // rpm = 60.00*(1000000/(timet*8));
 
 
      rpm_array[0] = rpm_array[1];
      rpm_array[1] = rpm_array[2];
      rpm_array[2] = rpm_array[3];
      rpm_array[3] = rpm_array[4];
      rpm_array[4] = 60*(1000000/(timet*8));    
    //Last 5 Average RPM Counts Eqauls....
      rpm = (rpm_array[0] + rpm_array[1] + rpm_array[2] + rpm_array[3] + rpm_array[4]) / 5;  
    

 
 
       
       
       
 delay(60);     


  lcd.setCursor(0, 1);
  lcd.print(rpm,0);
lcd.print(" RPM ");
lcd.print(timet,1);


}

void digitalClockDisplay()
{

lcd.setCursor(0, 0);  
lcd.print("MaxNC   "); //SET CHANNEL NAME HERE
if (hour()<10)
lcd.print(" ");
  lcd.print(hour());
  lcdprintDigits(minute()); 
  lcdprintDigits(second());  

//Alarm.delay(1000); // wait  between clock display  
}

void lcdprintDigits(int digits)
{
  // utility function for digital clock display: prints preceding colon and leading 0

  lcd.print(":"); 

  if(digits < 10)
   lcd.print('0');
 
 lcd.print(digits);
  
}

